/*
 |
 |	A simple X11 based program to take stdin and put it in cutbuffer0.
 |	When used with cutview, the input will be in both cutbuffer0 and
 |	the current selection.
 |
 |
 |	$Source: /home/hugh/sources/cview/xcat.c,v $
 |	$Author: hugh $
 |	$State: Exp $  $Locker:  $
 |	$Date: 2001/06/04 02:40:31 $
 |
 */

#define TRUE 1
#define FALSE 0

#include <stdio.h>
#include <fcntl.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <errno.h>
#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Xresource.h>

#define max(a, b) ((a) > (b) ? (a) : (b))

XtAppContext context_id;
Display *disp_ptr;
int bufferlen;
char *paste_buffer;
char *Display_name;
int size = 0;
char *buffer = NULL;

main(argc, argv)
int argc;
char *argv[];
{
	int counter;
	int result;
	int foo = 0;
	Arg arglist[10];
	char temp[1024];
	char name[128];
	char *temp_string;
	String *args = NULL;



#ifdef DEBUG
		if (!strcmp(argv[argc-1], "-DEBUG"))
		{
/*
 |	The following code will start an hpterm which will in turn execute 
 |	a debugger and "adopt" the process, so it can be debugged.
 */

			int child_id;
			char command_line[256];

			child_id = getpid();
			if (!fork())
			{
				sprintf(command_line, 
	      			"hpterm -fg wheat -bg DarkSlateGrey -n %s -e xdb %s -P %d", 
					"hello",  argv[0], child_id);
				execl("/bin/sh", "sh", "-c", command_line, NULL);
				fprintf(stderr, "could not exec new window\n");
				exit(1);
			}

/*
 |	When in debugger, set child_id to zero (p child_id=0) to continue 
 |	executing the software.
 */

			while (child_id != 0)
				;
		}
#endif

	if (argc > 1)
	{
		fprintf(stderr, "usage: xcat < file \n");
		fprintf(stderr, "   or  cat file | xcat\n");
		fprintf(stderr, " xcat takes stdin and puts it in cutbuffer0\n");
		exit(1);
	}

	context_id = XtCreateApplicationContext();
	disp_ptr = XtOpenDisplay(context_id, NULL, "", "xcat", NULL, 0, &foo, args);
	while ((result = read(0, &temp, 1024)) > 0)
	{
		if (size == 0)
			buffer = malloc(result);
		else
			buffer = realloc(buffer, (result + size));

		memcpy(&buffer[size], temp, result);
		size = size + result;

	}

	XStoreBytes(disp_ptr, buffer, size);
	XFlush(disp_ptr);

	exit(0);
}
